'use strict';
import * as _s0_t0 from '../support/glyph/index.mjs';
import * as _s0_t1 from '../support/glyph-store.mjs';
import * as _s0_t2 from '../support/glyph-block.mjs';
import * as _s0_t3 from '../support/gr.mjs';
import * as _s0_t4 from '../kits/spiro-kit.mjs';
import * as _s0_t5 from '../kits/boole-kit.mjs';
import * as _s0_t6 from '../meta/aesthetics.mjs';
import * as _s0_t7 from '../support/utils.mjs';
import * as _s0_t9 from './common/shapes.mjs';
import * as _s0_t10 from './common/derivatives.mjs';
import * as _s0_t11 from './space/index.mjs';
import * as _s0_t12 from './marks/index.mjs';
import * as _s0_t13 from './letter/shared.mjs';
import * as _s0_t14 from './letter/latin.mjs';
import * as _s0_t15 from './letter/greek.mjs';
import * as _s0_t16 from './letter/cyrillic.mjs';
import * as _s0_t17 from './number/index.mjs';
import * as _s0_t18 from './symbol/shared.mjs';
import * as _s0_t19 from './symbol/punctuation.mjs';
import * as _s0_t20 from './symbol/arrow.mjs';
import * as _s0_t21 from './symbol/geometric.mjs';
import * as _s0_t22 from './symbol/enclosure.mjs';
import * as _s0_t23 from './symbol/math.mjs';
import * as _s0_t24 from './symbol/letter.mjs';
import * as _s0_t25 from './symbol/braille.mjs';
import * as _s0_t26 from './symbol/mosaic.mjs';
import * as _s0_t27 from './symbol/pictograph.mjs';
import * as _s0_t28 from './symbol/ligation.mjs';
import * as _s0_t29 from './auto-build/special-accented-letters.mjs';
import * as _s0_t30 from './auto-build/mark-doppelganger.mjs';
import * as _s0_t31 from './auto-build/accents.mjs';
import * as _s0_t32 from './auto-build/composite.mjs';
import * as _s0_t33 from './auto-build/transformed.mjs';
var _s0_t8;
export {
    _s0_t8 as buildGlyphs
};
var r1_buildGlyphs, _r1_t0, _r1_t1, _r1_t2, _r1_t3, _r1_t4, _r1_t5, _r1_t6, _r1_t7;
var _r1_t8 = _s0_t0;
var r1_Glyph = _r1_t8.Glyph;
var _r1_t9 = _s0_t1;
var r1_GlyphStore = _r1_t9.GlyphStore;
var _r1_t10 = _s0_t2;
var r1_GlyphBlock = _r1_t10.GlyphBlock;
var r1_GlyphBlockExecState = _r1_t10.GlyphBlockExecState;
var r1_Gr = _s0_t3;
var r1_SpiroKit = _s0_t4;
var r1_BooleKit = _s0_t5;
var _r1_t11 = _s0_t6;
var r1_DesignParameters = _r1_t11.DesignParameters;
var r1_isFinite = isFinite;
var _r1_t12 = _s0_t7;
var r1_mix = _r1_t12.mix;
var r1_linreg = _r1_t12.linreg;
var r1_clamp = _r1_t12.clamp;
var r1_fallback = _r1_t12.fallback;
var _r1_t13 = _s0_t6;
var r1_calculateMetrics = _r1_t13.calculateMetrics;
var r1_setFontMetrics = _r1_t13.setFontMetrics;
var r1_MarksetDiv = _r1_t13.MarksetDiv;
var r1_GenDivFrame = _r1_t13.GenDivFrame;
var r1_xn$NamedParameterPair$2Lrc9b = function (r261_l, r261_r) {
    var _r261_t1;
    var _r261_t0 = this;
    _r261_t0.left = r261_l;
    _r261_t0.right = r261_r;
    return _r261_t0;
};
var r1_xn$DoNothing$2Lrc0b = function () {
    var _r262_t0, _r262_t1;
    return void 0;
};
_s0_t8 = r1_buildGlyphs = function (r264_para, r264_recursive) {
    var r264_gb, _r264_t4, _r264_t5;
    var r264_glyphStore = new r1_GlyphStore();
    var r264_Metrics = r1_calculateMetrics(r264_para);
    var r264_fontMetrics = {
        'head': {},
        'hhea': {},
        'os2': {},
        'post': {}
    };
    r1_setFontMetrics(r264_para, r264_Metrics, r264_fontMetrics);
    var _r264_t0 = [
        'AS-BASE',
        'ALSO-METRICS'
    ];
    var r264_AS_BASE = _r264_t0[0];
    var r264_ALSO_METRICS = _r264_t0[1];
    var r264_DivFrame = r1_GenDivFrame(r264_Metrics);
    var r264_MarkSet = r264_DivFrame(1, 2).markSet;
    var r264_xn$glyphisneeded$1aao3 = function (r265_name) {
        var _r265_t0, _r265_t1;
        return !r264_recursive || r264_recursive.glyphIsNeeded(r265_name);
    };
    var r264_xn$createAndSaveGlyphImpl$2Lrc3c = function (r266__1, r266__2, r266_actions) {
        var _r266_t0, _r266_t1;
        var r266_saveGlyphName = null;
        var r266_unicode = null;
        if (typeof r266__1 === 'number' && r266__1) {
            r266_saveGlyphName = 'uni' + r266__1.toString(16).padStart(4, '0').toUpperCase();
            r266_unicode = r266__1;
        } else if (typeof r266__1 === 'string' && r266__1) {
            r266_saveGlyphName = r266__1;
            r266_unicode = r266__2;
        } else if (true) {
            r266_saveGlyphName = null;
            r266_unicode = null;
        } else
            void 0;
        if (r266_saveGlyphName && !r264_xn$glyphisneeded$1aao3(r266_saveGlyphName))
            return void 0;
        if (r264_para.verbose)
            console.log(r266_saveGlyphName);
        var r266_glyphObject = new r1_Glyph(r266_saveGlyphName);
        r266_glyphObject.setWidth(r264_Metrics.Width);
        r266_glyphObject.gizmo = r264_Metrics.GlobalTransform;
        r266_glyphObject['_m_dependencyManager'] = r264_xn$execState$2Lrc0b.dependencyManager;
        r266_glyphObject.include(r266_actions, true, true);
        r264_xn$execState$2Lrc0b.setGlyphToBlockDependency(r266_glyphObject);
        if (r266_saveGlyphName) {
            if (r266_saveGlyphName[0] !== '.' && r264_glyphStore.queryByName(r266_saveGlyphName))
                throw new Error('Glyph ' + r266_saveGlyphName + ' already exists');
            r264_glyphStore.addGlyph(r266_saveGlyphName, r266_glyphObject);
            if (r266_unicode)
                r264_xn$assignUnicodeImpl$2Lrc8b(r266_glyphObject, r266_unicode);
        }
        return r266_glyphObject;
    };
    var r264_xn$assignUnicodeImpl$2Lrc8b = function (r267_g, r267_unicode) {
        var _r267_t0, _r267_t1;
        var r267_u = r267_unicode;
        if (typeof r267_unicode === 'string')
            r267_u = r267_unicode.codePointAt(0);
        return r264_glyphStore.encodeGlyph(r267_u, r267_g);
    };
    var r264_xn$pendingGlyphBlocks$2Lrc9b = [];
    var r264_xn$execState$2Lrc0b = new r1_GlyphBlockExecState();
    var r264_xn$defineGlyphBlockImpl$2Lrc1c = function (r268_xn$Capture$2Lrc8, r268_blockName, r268_body) {
        var _r268_t0, _r268_t1;
        var r268_glyphBlock = new r1_GlyphBlock(r268_xn$Capture$2Lrc8, r264_xn$execState$2Lrc0b, r268_blockName, r268_body);
        if (!r268_xn$Capture$2Lrc8[r268_blockName])
            r268_xn$Capture$2Lrc8[r268_blockName] = r268_glyphBlock;
        return r264_xn$pendingGlyphBlocks$2Lrc9b.push(r268_glyphBlock);
    };
    var r264_SpiroFns = r1_SpiroKit.SetupBuilders({
        'globalTransform': r264_Metrics.GlobalTransform,
        'Contrast': r264_Metrics.Contrast,
        'Stroke': r264_Metrics.Stroke,
        'Superness': r1_DesignParameters.superness
    });
    var r264_BooleFns = r1_BooleKit.SetupBuilders({
        'globalTransform': r264_Metrics.GlobalTransform,
        'Glyph': r1_Glyph
    });
    var r264_tagged = function (r269_tag, r269_component) {
        var _r269_t0, _r269_t1;
        return function (r270_ca, r270_cw) {
            var _r270_t1;
            var _r270_t0 = this;
            var r270_t = _r270_t0.ctxTag;
            _r270_t0.ctxTag = r269_tag;
            var r270_ret = _r270_t0.include(r269_component, r270_ca, r270_cw);
            _r270_t0.ctxTag = r270_t;
            return r270_ret;
        };
    };
    var r264_xn$Capture$2Lrc181 = {
        '$createAndSaveGlyphImpl$': r264_xn$createAndSaveGlyphImpl$2Lrc3c,
        '$NamedParameterPair$': r1_xn$NamedParameterPair$2Lrc9b,
        '$assignUnicodeImpl$': r264_xn$assignUnicodeImpl$2Lrc8b,
        '$defineGlyphBlockImpl$': r264_xn$defineGlyphBlockImpl$2Lrc1c,
        '$execState$': r264_xn$execState$2Lrc0b,
        '$DoNothing$': r1_xn$DoNothing$2Lrc0b,
        'Metrics': Object.assign({}, r264_Metrics),
        'para': r264_para,
        'recursive': r264_recursive,
        'glyphStore': r264_glyphStore,
        'SpiroFns': r264_SpiroFns,
        'BooleFns': r264_BooleFns,
        'DivFrame': r264_DivFrame,
        'MarkSet': r264_MarkSet,
        'AS_BASE': r264_AS_BASE,
        'ALSO_METRICS': r264_ALSO_METRICS,
        'glyph-is-needed': r264_xn$glyphisneeded$1aao3,
        'buildGlyphs': r1_buildGlyphs,
        'tagged': r264_tagged,
        'fontMetrics': r264_fontMetrics
    };
    _s0_t9.apply.call(r264_xn$Capture$2Lrc181);
    _s0_t10.apply.call(r264_xn$Capture$2Lrc181);
    _s0_t11.apply.call(r264_xn$Capture$2Lrc181);
    _s0_t12.apply.call(r264_xn$Capture$2Lrc181);
    _s0_t13.apply.call(r264_xn$Capture$2Lrc181);
    _s0_t14.apply.call(r264_xn$Capture$2Lrc181);
    _s0_t15.apply.call(r264_xn$Capture$2Lrc181);
    _s0_t16.apply.call(r264_xn$Capture$2Lrc181);
    _s0_t17.apply.call(r264_xn$Capture$2Lrc181);
    _s0_t18.apply.call(r264_xn$Capture$2Lrc181);
    _s0_t19.apply.call(r264_xn$Capture$2Lrc181);
    _s0_t20.apply.call(r264_xn$Capture$2Lrc181);
    _s0_t21.apply.call(r264_xn$Capture$2Lrc181);
    _s0_t22.apply.call(r264_xn$Capture$2Lrc181);
    _s0_t23.apply.call(r264_xn$Capture$2Lrc181);
    _s0_t24.apply.call(r264_xn$Capture$2Lrc181);
    _s0_t25.apply.call(r264_xn$Capture$2Lrc181);
    _s0_t26.apply.call(r264_xn$Capture$2Lrc181);
    _s0_t27.apply.call(r264_xn$Capture$2Lrc181);
    _s0_t28.apply.call(r264_xn$Capture$2Lrc181);
    if (!r264_recursive) {
        _s0_t29.apply.call(r264_xn$Capture$2Lrc181);
        _s0_t30.apply.call(r264_xn$Capture$2Lrc181);
        _s0_t31.apply.call(r264_xn$Capture$2Lrc181);
        _s0_t32.apply.call(r264_xn$Capture$2Lrc181);
        _s0_t33.apply.call(r264_xn$Capture$2Lrc181);
    }
    var _r264_t1 = r264_xn$pendingGlyphBlocks$2Lrc9b;
    var _r264_t2 = _r264_t1.length;
    var _r264_t3 = 0;
    while (_r264_t3 < _r264_t2) {
        r264_gb = _r264_t1[_r264_t3];
        r264_gb.resolve();
        _r264_t3 = _r264_t3 + 1;
    }
    r1_Gr.linkSuffixPairGr(r264_glyphStore, 'NWID', 'WWID', r1_Gr.Nwid, r1_Gr.Wwid);
    r1_Gr.linkSuffixPairGr(r264_glyphStore, 'lnum', 'onum', r1_Gr.Lnum, r1_Gr.Onum);
    r1_Gr.linkSuffixGr(r264_glyphStore, 'aplForm', r1_Gr.AplForm);
    return {
        'glyphStore': r264_glyphStore,
        'fontMetrics': r264_fontMetrics
    };
};
